/* ========================================================================
 * PlantUML : a free UML diagram generator
 * ========================================================================
 *
 * (C) Copyright 2009-2014, Arnaud Roques
 *
 * Project Info:  http://plantuml.sourceforge.net
 * 
 * This file is part of PlantUML.
 *
 * Licensed under The MIT License (Massachusetts Institute of Technology License)
 * 
 * See http://opensource.org/licenses/MIT
 * 
 * Permission is hereby granted, free of charge, to any person obtaining
 * a copy of this software and associated documentation files (the "Software"),
 * to deal in the Software without restriction, including without limitation
 * the rights to use, copy, modify, merge, publish, distribute, sublicense,
 * and/or sell copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following conditions:
 * 
 * The above copyright notice and this permission notice shall be included
 * in all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
 * OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR
 * IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 * 
 *
 * Original Author:  Arnaud Roques
 */
package net.sourceforge.plantuml.graphic;


public class HtmlColorUtils {

	public static final String COLOR_REGEXP = "#\\w+[-\\\\|/]?\\w+";

	public static final HtmlColor BLACK;
	public static final HtmlColor WHITE;
	public static final HtmlColor RED_LIGHT;
	public static final HtmlColor RED_DARK;
	public static final HtmlColor RED;
	public static final HtmlColor GREEN;
	public static final HtmlColor BLUE;
	public static final HtmlColor GRAY;
	public static final HtmlColor LIGHT_GRAY;
	public static final HtmlColor MY_YELLOW;
	public static final HtmlColor MY_RED;

	public static final HtmlColor COL_C82930;
	public static final HtmlColor COL_F24D5C;
	public static final HtmlColor COL_1963A0;
	public static final HtmlColor COL_4177AF;
	public static final HtmlColor COL_B38D22;
	public static final HtmlColor COL_FFFF44;
	public static final HtmlColor COL_038048;
	public static final HtmlColor COL_84BE84;
	public static final HtmlColor COL_DDDDDD;
	public static final HtmlColor COL_EEEEEE;
	public static final HtmlColor COL_FBFB77;
	public static final HtmlColor COL_ADD1B2;
	public static final HtmlColor COL_A9DCDF;
	public static final HtmlColor COL_EB937F;
	public static final HtmlColor COL_B4A7E5;
	public static final HtmlColor COL_527BC6;
	public static final HtmlColor COL_D1DBEF;
	public static final HtmlColor COL_D7E0F2;
	public static final HtmlColor COL_989898;
	public static final HtmlColor COL_BBBBBB;
	

	static {

		final IHtmlColorSet set = new HtmlColorSetSimple();

		BLACK = set.getColorIfValid("black");
		WHITE = set.getColorIfValid("white");
		RED_LIGHT = set.getColorIfValid("#FEF6F3");
		RED_DARK = set.getColorIfValid("#CD0A0A");
		RED = set.getColorIfValid("#FF0000");
		GREEN = set.getColorIfValid("#00FF00");
		BLUE = set.getColorIfValid("#0000FF");
		GRAY = set.getColorIfValid("#808080");
		LIGHT_GRAY = set.getColorIfValid("#C0C0C0");
		MY_YELLOW = set.getColorIfValid("#FEFECE");
		MY_RED = set.getColorIfValid("#A80036");

		COL_C82930 = set.getColorIfValid("#C82930");
		COL_F24D5C = set.getColorIfValid("#F24D5C");
		COL_1963A0 = set.getColorIfValid("#1963A0");
		COL_4177AF = set.getColorIfValid("#4177AF");
		COL_B38D22 = set.getColorIfValid("#B38D22");
		COL_FFFF44 = set.getColorIfValid("#FFFF44");
		COL_038048 = set.getColorIfValid("#038048");
		COL_84BE84 = set.getColorIfValid("#84BE84");
		COL_DDDDDD = set.getColorIfValid("#DDDDDD");
		COL_EEEEEE = set.getColorIfValid("#EEEEEE");
		COL_FBFB77 = set.getColorIfValid("#FBFB77");
		COL_ADD1B2 = set.getColorIfValid("#ADD1B2");
		COL_A9DCDF = set.getColorIfValid("#A9DCDF");
		COL_EB937F = set.getColorIfValid("#EB937F");
		COL_B4A7E5 = set.getColorIfValid("#B4A7E5");
		COL_527BC6 = set.getColorIfValid("#527BC6");
		COL_D1DBEF = set.getColorIfValid("#D1DBEF");
		COL_D7E0F2 = set.getColorIfValid("#D7E0F2");
		COL_989898 = set.getColorIfValid("#989898");
		COL_BBBBBB = set.getColorIfValid("#BBBBBB");

	}

}
